diff --git a/gdbstub.c b/gdbstub.c
index 528404c1953..4c3e211890f 100644
--- a/gdbstub.c
+++ b/gdbstub.c
@@ -366,6 +366,7 @@ typedef struct GDBState {
     char syscall_buf[256];
     gdb_syscall_complete_cb current_syscall_cb;
     GString *str_buf;
+    GByteArray *mem_buf;
 } GDBState;
 
 /* By default use no IRQs and no timers while single stepping so as to
@@ -380,6 +381,7 @@ static GDBState *gdb_allocate_state(void)
     g_assert(!gdbserver_state);
     gdbserver_state = g_new0(GDBState, 1);
     gdbserver_state->str_buf = g_string_new(NULL);
+    gdbserver_state->mem_buf = g_byte_array_sized_new(MAX_PACKET_LENGTH);
     return gdbserver_state;
 }
 
@@ -566,12 +568,13 @@ static void memtohex(GString *buf, const uint8_t *mem, int len)
     g_string_append_c(buf, '\0');
 }
 
-static void hextomem(uint8_t *mem, const char *buf, int len)
+static void hextomem(GByteArray *mem, const char *buf, int len)
 {
     int i;
 
     for(i = 0; i < len; i++) {
-        mem[i] = (fromhex(buf[0]) << 4) | fromhex(buf[1]);
+        guint8 byte = fromhex(buf[0]) << 4 | fromhex(buf[1]);
+        g_byte_array_append(mem, &byte, 1);
         buf += 2;
     }
 }
@@ -1396,7 +1399,6 @@ static int cmd_parse_params(const char *data, const char *schema,
 typedef struct GdbCmdContext {
     GdbCmdVariant *params;
     int num_params;
-    uint8_t mem_buf[MAX_PACKET_LENGTH];
 } GdbCmdContext;
 
 typedef void (*GdbCmdHandler)(GdbCmdContext *gdb_ctx, void *user_ctx);
@@ -1489,6 +1491,7 @@ static void run_cmd_parser(GDBState *s, const char *data,
     }
 
     g_string_set_size(s->str_buf, 0);
+    g_byte_array_set_size(s->mem_buf, 0);
 
     /* In case there was an error during the command parsing we must
     * send a NULL packet to indicate the command is not supported */
@@ -1710,8 +1713,8 @@ static void handle_set_reg(GdbCmdContext *gdb_ctx, void *user_ctx)
     }
 
     reg_size = strlen(gdb_ctx->params[1].data) / 2;
-    hextomem(gdb_ctx->mem_buf, gdb_ctx->params[1].data, reg_size);
-    gdb_write_register(s->g_cpu, gdb_ctx->mem_buf,
+    hextomem(s->mem_buf, gdb_ctx->params[1].data, reg_size);
+    gdb_write_register(s->g_cpu, s->mem_buf->data,
                        gdb_ctx->params[0].val_ull);
     put_packet(s, "OK");
 }
@@ -1731,14 +1734,16 @@ static void handle_get_reg(GdbCmdContext *gdb_ctx, void *user_ctx)
         return;
     }
 
-    reg_size = gdb_read_register(s->g_cpu, gdb_ctx->mem_buf,
+    reg_size = gdb_read_register(s->g_cpu, s->mem_buf->data,
                                  gdb_ctx->params[0].val_ull);
     if (!reg_size) {
         put_packet(s, "E14");
         return;
+    } else {
+        g_byte_array_set_size(s->mem_buf, reg_size);
     }
 
-    memtohex(s->str_buf, gdb_ctx->mem_buf, reg_size);
+    memtohex(s->str_buf, s->mem_buf->data, reg_size);
     put_packet(s, s->str_buf->str);
 }
 
@@ -1757,11 +1762,11 @@ static void handle_write_mem(GdbCmdContext *gdb_ctx, void *user_ctx)
         return;
     }
 
-    hextomem(gdb_ctx->mem_buf, gdb_ctx->params[2].data,
+    hextomem(s->mem_buf, gdb_ctx->params[2].data,
              gdb_ctx->params[1].val_ull);
     if (target_memory_rw_debug(s->g_cpu, gdb_ctx->params[0].val_ull,
-                               gdb_ctx->mem_buf,
-                               gdb_ctx->params[1].val_ull, true)) {
+                               s->mem_buf->data,
+                               s->mem_buf->len, true)) {
         put_packet(s, "E14");
         return;
     }
@@ -1784,14 +1789,16 @@ static void handle_read_mem(GdbCmdContext *gdb_ctx, void *user_ctx)
         return;
     }
 
+    g_byte_array_set_size(s->mem_buf, gdb_ctx->params[1].val_ull);
+
     if (target_memory_rw_debug(s->g_cpu, gdb_ctx->params[0].val_ull,
-                               gdb_ctx->mem_buf,
-                               gdb_ctx->params[1].val_ull, false)) {
+                               s->mem_buf->data,
+                               s->mem_buf->len, false)) {
         put_packet(s, "E14");
         return;
     }
 
-    memtohex(s->str_buf, gdb_ctx->mem_buf, gdb_ctx->params[1].val_ull);
+    memtohex(s->str_buf, s->mem_buf->data, s->mem_buf->len);
     put_packet(s, s->str_buf->str);
 }
 
@@ -1807,9 +1814,9 @@ static void handle_write_all_regs(GdbCmdContext *gdb_ctx, void *user_ctx)
     }
 
     cpu_synchronize_state(s->g_cpu);
-    registers = gdb_ctx->mem_buf;
     len = strlen(gdb_ctx->params[0].data) / 2;
-    hextomem(registers, gdb_ctx->params[0].data, len);
+    hextomem(s->mem_buf, gdb_ctx->params[0].data, len);
+    registers = s->mem_buf->data;
     for (addr = 0; addr < s->g_cpu->gdb_num_g_regs && len > 0;
          addr++) {
         reg_size = gdb_write_register(s->g_cpu, registers, addr);
@@ -1827,11 +1834,13 @@ static void handle_read_all_regs(GdbCmdContext *gdb_ctx, void *user_ctx)
     cpu_synchronize_state(s->g_cpu);
     len = 0;
     for (addr = 0; addr < s->g_cpu->gdb_num_g_regs; addr++) {
-        len += gdb_read_register(s->g_cpu, gdb_ctx->mem_buf + len,
+        len += gdb_read_register(s->g_cpu, s->mem_buf->data + len,
                                  addr);
     }
+    /* FIXME: This is after the fact sizing */
+    g_byte_array_set_size(s->mem_buf, len);
 
-    memtohex(s->str_buf, gdb_ctx->mem_buf, len);
+    memtohex(s->str_buf, s->mem_buf->data, len);
     put_packet(s, s->str_buf->str);
 }
 
@@ -2102,6 +2111,7 @@ static void handle_query_offsets(GdbCmdContext *gdb_ctx, void *user_ctx)
 static void handle_query_rcmd(GdbCmdContext *gdb_ctx, void *user_ctx)
 {
     GDBState *s = gdbserver_state;
+    const guint8 zero = 0;
     int len;
 
     if (!gdb_ctx->num_params) {
@@ -2116,11 +2126,11 @@ static void handle_query_rcmd(GdbCmdContext *gdb_ctx, void *user_ctx)
     }
 
     len = len / 2;
-    hextomem(gdb_ctx->mem_buf, gdb_ctx->params[0].data, len);
-    gdb_ctx->mem_buf[len++] = 0;
-    qemu_chr_be_write(s->mon_chr, gdb_ctx->mem_buf, len);
+    g_byte_array_set_size(s->mem_buf, len);
+    hextomem(s->mem_buf, gdb_ctx->params[0].data, len);
+    g_byte_array_append(s->mem_buf, &zero, 1);
+    qemu_chr_be_write(s->mon_chr, s->mem_buf->data, s->mem_buf->len);
     put_packet(s, "OK");
-
 }
 #endif
 